package cc.javastudio.raw;

import java.io.*;


public final class FileHandler implements Closeable {
    private final int INT_LENGTH  = 4;
    private final int BYTE_LENGTH  = 1;
    private RandomAccessFile dbFile;


    //constructor maken
    public FileHandler(String dbFileName) throws FileNotFoundException {
        dbFile = new RandomAccessFile(dbFileName, "rw" );

    }

    public void add(String name,
                    int age,
                    String address,
                    String licencePlate,
                    String description) throws IOException {


        //position file pointer at the end of the file
        long bytePosition = dbFile.length();
        Index.getInstance().add(bytePosition);

        dbFile.seek(bytePosition);

        // calculate the total length of the record (4 is aantal voor Integer + INT_LENGTH),
        // voor elk veld wordt gezet hoe lang het is)
        int recordLength =  INT_LENGTH + name.getBytes().length +
                            INT_LENGTH +     // STAAT VOOR AGE
                            INT_LENGTH + address.getBytes().length +
                            INT_LENGTH + licencePlate.getBytes().length +
                            INT_LENGTH + description.getBytes().length;

        dbFile.writeBoolean(false);
        dbFile.writeInt(recordLength);
        dbFile.writeInt(name.getBytes().length);
        dbFile.write(name.getBytes());
        dbFile.writeInt(age);
        dbFile.writeInt(address.getBytes().length);
        dbFile.write(address.getBytes());
        dbFile.writeInt(licencePlate.getBytes().length);
        dbFile.write(licencePlate.getBytes());
        dbFile.writeInt(description.getBytes().length);
        dbFile.write(description.getBytes());

    }

    public Person readRow(long rowNumber) throws IOException {

        long BytePosition = Index.getInstance().getBytePosition(rowNumber);
        if (BytePosition == -1){
            return null;
        }

        byte [] rawData = readRawRow(0);
        DataInputStream stream = new DataInputStream(new ByteArrayInputStream(rawData));

        Person person = new Person();
        int stringlength = stream.readInt();
        byte [] b = new byte[stringlength];
        stream.read(b);
        person.name = new String (b);

        person.age = stream.readInt();

        stringlength = stream.readInt();
        b = new byte[stringlength];
        stream.read(b);
        person.address = new String (b);

        stringlength = stream.readInt();
        b = new byte[stringlength];
        stream.read(b);
        person.LicencePlate = new String (b);

        stringlength = stream.readInt();
        b = new byte[stringlength];
        stream.read(b);
        person.description = new String (b);

        return person;
    }

    private byte [] readRawRow(long bytePosition) throws IOException {

        dbFile.seek(bytePosition);

        if (dbFile.readBoolean()){
            return new byte [0];
        } else {
            int recordLegnth  = dbFile.readInt();  // lees lengte volledige rij
            byte [] rawData = new byte[recordLegnth ];  // maak een nieuwe bytearay aan
            dbFile.read(rawData);
            return rawData;
        }
    }

    public void loadIndex () throws IOException {
        if (dbFile.length()==0){
            return;
        }
        long bytePos = 0;
        while (bytePos < dbFile.length()) {
            dbFile.seek(bytePos);
            boolean IsDeleted = dbFile.readBoolean();
            if (!IsDeleted ) {
                Index.getInstance().add(bytePos);
            }
            bytePos += BYTE_LENGTH;
            int recordLength = dbFile.readInt();
            bytePos +=  INT_LENGTH + recordLength;

        }
    }

    public void close() throws IOException {
        dbFile.close();
    }
}