package cc.javastudio.raw;

import java.util.HashMap;

public final class Index {
    //singleton aanmaken

    private static Index index = new Index();  // static geplakt aan classe niet aan object
    private HashMap<Long,Long> rowindex;
    private long totalRowNumber = 0;


    private Index() {
        rowindex = new HashMap<>();
    }

    //statische methode die gaat kijken of index een referentie heeft
    public static Index getInstance() {
        return index;
    }

    public void add (Long bytePosition) {
        rowindex.put(totalRowNumber,bytePosition);
        totalRowNumber++;
    }

    public void remove(Long row){
        rowindex.remove(row);
        totalRowNumber--;
    }

    public long getTotalRowNumberOfRows(){
        return totalRowNumber;
    }

    public long getBytePosition(Long totalRowNumber){
        return rowindex.getOrDefault(totalRowNumber, (long) -1);
    }

}

